$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_NAVIGATION_HEADER_PANEL_ID$ = "navigator";
function $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$() {
  $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$superclass$.constructor.call(this, $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_NAVIGATION_HEADER_PANEL_ID$);
}
$goog$exportSymbol$$("AdfDhtmlChooseDateMonthNavigationHeaderPanel", $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$);
$AdfObject$$.$createSubclass$($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$, $AdfDhtmlChooseDateNavigationPanelBase$$);
$AdfDhtmlChooseDateLayoutPanel$$.$registerLayoutPanel$($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$);
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$canProcessDomUIInputEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$canProcessDomUIInputEvent$$($component$$434$$, $componentEvent$$41$$) {
  $AdfAssert$$.$assertPrototype$($component$$434$$, AdfRichChooseDate);
  $AdfAssert$$.$assertPrototype$($componentEvent$$41$$, $AdfDomUIInputEvent$$);
  return $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$superclass$.$canProcessDomUIInputEvent$.call(this, $component$$434$$, $componentEvent$$41$$) || $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_eventTargetsElementWithAttribute$($componentEvent$$41$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$) || $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_eventTargetsElementWithAttribute$($componentEvent$$41$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$) ? !0 : !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.canProcessDomUIInputEvent", {$canProcessDomUIInputEvent$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$canProcessDomUIInputEvent$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$canProcessComponentEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$canProcessComponentEvent$$($component$$435$$, $componentEvent$$42$$) {
  $AdfAssert$$.$assertPrototype$($component$$435$$, AdfRichChooseDate);
  $AdfAssert$$.$assertPrototype$($componentEvent$$42$$, $AdfComponentEvent$$);
  return $componentEvent$$42$$ instanceof $AdfChooseDateYearSelectingEvent$$ || $componentEvent$$42$$ instanceof $AdfChooseDateYearSelectionEvent$$ || $componentEvent$$42$$ instanceof $AdfChooseDateMonthSelectingEvent$$ || $componentEvent$$42$$ instanceof $AdfChooseDateMonthSelectionEvent$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.canProcessComponentEvent", {$canProcessComponentEvent$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$canProcessComponentEvent$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$handleComponentKeyDown$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$handleComponentKeyDown$$($component$$436$$, $componentEvent$$43$$) {
  $AdfAssert$$.$assertPrototype$($component$$436$$, AdfRichChooseDate);
  $AdfAssert$$.$assertPrototype$($componentEvent$$43$$, $AdfComponentEvent$$);
  if ($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$superclass$.$handleComponentKeyDown$.call(this, $component$$436$$, $componentEvent$$43$$)) {
    return !0;
  }
  var $eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$ = $componentEvent$$43$$.$getNativeEventTarget$(), $agent$$81$$ = $AdfAgent$$.$AGENT$;
  if ($agent$$81$$.$getNodeName$($eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$) == $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$) {
    var $keyCode$$16_monthAttrVal$$ = $agent$$81$$.getAttribute($eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$), $eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$ = $agent$$81$$.getAttribute($eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$);
    if (null != $keyCode$$16_monthAttrVal$$ || null != $eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$) {
      switch($keyCode$$16_monthAttrVal$$ = $AdfAgent$$.$AGENT$.$getKeyCode$($componentEvent$$43$$.$getNativeEvent$()), $eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$ = this.$getPanelRootElement$($component$$436$$), $keyCode$$16_monthAttrVal$$) {
        case $AdfKeyStroke$$.$ARROWUP_KEY$:
        ;
        case $AdfKeyStroke$$.$ARROWDOWN_KEY$:
        ;
        case $AdfKeyStroke$$.$ARROWRIGHT_KEY$:
        ;
        case $AdfKeyStroke$$.$ARROWLEFT_KEY$:
          return $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleArrowKeyNavigation$($componentEvent$$43$$, $eventTargetNode$$3_panelRootElement$$7_yearAttrVal$$);
      }
    }
  }
  return !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.handleComponentKeyDown", {$handleComponentKeyDown$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$handleComponentKeyDown$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$ConstructNewRichComponents$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$ConstructNewRichComponents$$() {
  return [];
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.ConstructNewRichComponents", {$ConstructNewRichComponents$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$ConstructNewRichComponents$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$HandleComponentEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$HandleComponentEvent$$($component$$439$$, $componentEvent$$45$$) {
  $AdfAssert$$.$assertPrototype$($component$$439$$, AdfRichChooseDate);
  $AdfAssert$$.$assertPrototype$($componentEvent$$45$$, $AdfComponentEvent$$);
  if ($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$superclass$.$HandleComponentEvent$.call(this, $component$$439$$, $componentEvent$$45$$)) {
    return !0;
  }
  var $panelRootElem$$1$$ = this.$getPanelRootElement$($component$$439$$), $targetElem$$ = $componentEvent$$45$$.$getNativeEventTarget$();
  return $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_eventTargetsElementWithAttribute$($componentEvent$$45$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$) ? $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_queueMonthEvent$($component$$439$$, $panelRootElem$$1$$, $targetElem$$) : $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_eventTargetsElementWithAttribute$($componentEvent$$45$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$) ? $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_queueYearEvent$($component$$439$$, 
  $panelRootElem$$1$$, $targetElem$$) : !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.HandleComponentEvent", {$HandleComponentEvent$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$HandleComponentEvent$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$UpdateGridHeader$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$UpdateGridHeader$$($component$$440_decadeStart$$2$$, $rootDOMElem$$2$$, $monthGrid$$1_yearLabelCell$$, $month$$8_printMonthAndYear$$1$$, $monthNames$$4$$) {
  $AdfAssert$$.$assertPrototype$($component$$440_decadeStart$$2$$, AdfRichChooseDate);
  $AdfAssert$$.$assertDomElement$($rootDOMElem$$2$$);
  $AdfAssert$$.$assertDomElement$($monthGrid$$1_yearLabelCell$$);
  $AdfAssert$$.$assertDate$($month$$8_printMonthAndYear$$1$$);
  $AdfAssert$$.$assertArray$($monthNames$$4$$);
  var $agent$$83$$ = $AdfAgent$$.$AGENT$, $year$$9$$ = $month$$8_printMonthAndYear$$1$$.getFullYear();
  $month$$8_printMonthAndYear$$1$$ = $month$$8_printMonthAndYear$$1$$.getMonth();
  $agent$$83$$.setAttribute($monthGrid$$1_yearLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_YYYY_MM$, $year$$9$$ + "-" + $month$$8_printMonthAndYear$$1$$);
  var $monthLabelCell$$ = $AdfDomUtils$$.$getFirstElementByTagName$($monthGrid$$1_yearLabelCell$$, $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$);
  $AdfAssert$$.$assertDomElement$($monthLabelCell$$);
  $AdfAssert$$.assert(null != $agent$$83$$.getAttribute($monthLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$));
  $monthGrid$$1_yearLabelCell$$ = $AdfDomUtils$$.$getNextElement$($monthLabelCell$$);
  $AdfAssert$$.$assertDomElement$($monthGrid$$1_yearLabelCell$$);
  $AdfAssert$$.assert(null != $agent$$83$$.getAttribute($monthGrid$$1_yearLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$));
  $AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$440_decadeStart$$2$$, $rootDOMElem$$2$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$) ? ($agent$$83$$.setAttribute($monthLabelCell$$, "style", "display: none;"), $agent$$83$$.setAttribute($monthLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$, null), $agent$$83$$.setAttribute($monthGrid$$1_yearLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$, $year$$9$$), $AdfDhtmlChooseDateDOMQueries$$.$isThaiBuddhistCalendar$($component$$440_decadeStart$$2$$, 
  $rootDOMElem$$2$$) && ($year$$9$$ += $AdfDhtmlChooseDatePeer$$.$_THAI_BUDDHIST_YEAR_OFFSET$), $component$$440_decadeStart$$2$$ = 10 * parseInt($year$$9$$ / 10), $monthGrid$$1_yearLabelCell$$.textContent = $component$$440_decadeStart$$2$$ + " - " + ($component$$440_decadeStart$$2$$ + 9)) : ($agent$$83$$.setAttribute($monthLabelCell$$, "style", "display: inline-block"), $agent$$83$$.setAttribute($monthLabelCell$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$, $month$$8_printMonthAndYear$$1$$), $agent$$83$$.setAttribute($monthGrid$$1_yearLabelCell$$, 
  $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$, $year$$9$$), $monthLabelCell$$.textContent = $monthNames$$4$$[$month$$8_printMonthAndYear$$1$$], $AdfDhtmlChooseDateDOMQueries$$.$isThaiBuddhistCalendar$($component$$440_decadeStart$$2$$, $rootDOMElem$$2$$) && ($year$$9$$ += $AdfDhtmlChooseDatePeer$$.$_THAI_BUDDHIST_YEAR_OFFSET$), $monthGrid$$1_yearLabelCell$$.textContent = $year$$9$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.UpdateGridHeader", {$UpdateGridHeader$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$UpdateGridHeader$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$BuildCalendarLabelForMonth$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$BuildCalendarLabelForMonth$$($component$$441$$, $cdRootElem$$37_pivotMonthAndYear$$4$$, $laf$$23_yearLabel$$, $headerTableRow$$1_monthYearContainer$$, $month$$9$$, $year$$10$$) {
  $headerTableRow$$1_monthYearContainer$$ = $AdfDhtmlChooseDateDOMUtils$$.$createAndAppendElement$("td", {"class":$laf$$23_yearLabel$$.getStyleClass("af|chooseDate::month-year-label-cell"), "data-afr-mnt-yr-lbl":"true"}, $headerTableRow$$1_monthYearContainer$$);
  $cdRootElem$$37_pivotMonthAndYear$$4$$ = $AdfDhtmlChooseDateDOMQueries$$.$getRenderedMonthAndYear$($component$$441$$, $cdRootElem$$37_pivotMonthAndYear$$4$$);
  var $isTabStop$$ = $cdRootElem$$37_pivotMonthAndYear$$4$$.getMonth() == $month$$9$$ && $cdRootElem$$37_pivotMonthAndYear$$4$$.getFullYear() == $year$$10$$;
  $cdRootElem$$37_pivotMonthAndYear$$4$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$441$$);
  var $monthNames$$5$$ = $AdfDhtmlChooseDateDOMQueries$$.$getLocaleSymbols$($component$$441$$, $cdRootElem$$37_pivotMonthAndYear$$4$$).getMonths().slice(0, 12), $monthLabel$$ = $AdfDhtmlChooseDateDOMUtils$$.$createAndAppendElement$($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$, {"class":$laf$$23_yearLabel$$.getStyleClass("af|chooseDate::month-label-text"), "data-afr-month":$month$$9$$, role:"button", tabindex:$isTabStop$$ ? "0" : "-1"}, $headerTableRow$$1_monthYearContainer$$);
  $cdRootElem$$37_pivotMonthAndYear$$4$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$441$$);
  $monthNames$$5$$ = $AdfDhtmlChooseDateDOMQueries$$.$getLocaleSymbols$($component$$441$$, $cdRootElem$$37_pivotMonthAndYear$$4$$).getMonths().slice(0, 12);
  $monthLabel$$.textContent = $monthNames$$5$$[$month$$9$$];
  $laf$$23_yearLabel$$ = $AdfDhtmlChooseDateDOMUtils$$.$createAndAppendElement$($AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$, {"class":$laf$$23_yearLabel$$.getStyleClass("af|chooseDate::year-label-text"), "data-afr-year":$year$$10$$, role:"button", tabindex:$isTabStop$$ ? "0" : "-1"}, $headerTableRow$$1_monthYearContainer$$);
  $AdfDhtmlChooseDateDOMQueries$$.$isThaiBuddhistCalendar$($component$$441$$, $cdRootElem$$37_pivotMonthAndYear$$4$$) && ($year$$10$$ += $AdfDhtmlChooseDatePeer$$.$_THAI_BUDDHIST_YEAR_OFFSET$);
  $laf$$23_yearLabel$$.textContent = $year$$10$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.BuildCalendarLabelForMonth", {$BuildCalendarLabelForMonth$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$BuildCalendarLabelForMonth$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$ManipulateMonth$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$ManipulateMonth$$($component$$442_isYearSelectingMode$$14$$, $cdRootElem$$38$$, $currentMonthYear$$1_year$$11$$, $increment$$2_yearDeltaChange$$1$$) {
  $AdfAssert$$.$assertPrototype$($component$$442_isYearSelectingMode$$14$$, AdfRichChooseDate);
  $AdfAssert$$.$assertBoolean$($increment$$2_yearDeltaChange$$1$$);
  var $month$$10$$ = $currentMonthYear$$1_year$$11$$.getMonth();
  $currentMonthYear$$1_year$$11$$ = $currentMonthYear$$1_year$$11$$.getFullYear();
  var $delta$$6$$ = Math.min(12, $AdfDhtmlChooseDateDOMQueries$$.$getMonthsToDisplay$($component$$442_isYearSelectingMode$$14$$, $cdRootElem$$38$$));
  $cdRootElem$$38$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$442_isYearSelectingMode$$14$$);
  var $isMonthSelectingMode$$3$$ = $AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$442_isYearSelectingMode$$14$$, $cdRootElem$$38$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_MONTH_MODE$);
  $component$$442_isYearSelectingMode$$14$$ = $AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$442_isYearSelectingMode$$14$$, $cdRootElem$$38$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$);
  $isMonthSelectingMode$$3$$ ? $currentMonthYear$$1_year$$11$$ += $increment$$2_yearDeltaChange$$1$$ ? $delta$$6$$ : -1 * $delta$$6$$ : $component$$442_isYearSelectingMode$$14$$ ? $currentMonthYear$$1_year$$11$$ += $increment$$2_yearDeltaChange$$1$$ ? 10 * $delta$$6$$ : -10 * $delta$$6$$ : ($month$$10$$ = $increment$$2_yearDeltaChange$$1$$ ? $month$$10$$ + $delta$$6$$ : $month$$10$$ - $delta$$6$$, $increment$$2_yearDeltaChange$$1$$ = 0, 0 > $month$$10$$ ? ($month$$10$$ += 12, $increment$$2_yearDeltaChange$$1$$ = 
  -1) : 11 < $month$$10$$ && ($month$$10$$ -= 12, $increment$$2_yearDeltaChange$$1$$ = 1), $increment$$2_yearDeltaChange$$1$$ && ($currentMonthYear$$1_year$$11$$ += $increment$$2_yearDeltaChange$$1$$));
  return {month:$month$$10$$, year:$currentMonthYear$$1_year$$11$$};
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.ManipulateMonth", {$ManipulateMonth$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$ManipulateMonth$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$GetMonthDisplayRange$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$GetMonthDisplayRange$$($component$$443$$) {
  var $panelRoot$$13$$ = this.$getPanelRootElement$($component$$443$$);
  return $panelRoot$$13$$ ? $AdfDhtmlChooseDateDOMQueries$$.$getNavigationGridDisplayRange$($component$$443$$, $panelRoot$$13$$) : $AdfDhtmlChooseDateDOMQueries$$.$getMonthDisplayRange$($component$$443$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.GetMonthDisplayRange", {$GetMonthDisplayRange$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$GetMonthDisplayRange$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$GetNextDisplayedMonth$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$GetNextDisplayedMonth$$($component$$444$$, $monthAndYear$$1$$) {
  return $AdfDhtmlChooseDateDOMQueries$$.$getNextNavigationGridDisplayDate$($component$$444$$, $monthAndYear$$1$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.GetNextDisplayedMonth", {$GetNextDisplayedMonth$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$GetNextDisplayedMonth$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$getSubIdDomElement$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$$getSubIdDomElement$$($component$$445$$, $subElementId$$3$$) {
  $AdfAssert$$.$assertPrototype$($component$$445$$, AdfRichChooseDate);
  $AdfAssert$$.$assertString$($subElementId$$3$$);
  if ("monthSelector" == $subElementId$$3$$ || "yearSelector" == $subElementId$$3$$) {
    var $agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$ = $AdfAgent$$.$AGENT$, $cdRootElem$$39_gridId$$3_pivotMonth$$2$$ = $AdfRichUIPeer$$.$CreateSubId$($component$$445$$.$getClientId$(), $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_NAVIGATION_HEADER_PANEL_ID$), $agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$ = $agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$.getElementById($cdRootElem$$39_gridId$$3_pivotMonth$$2$$);
    if (!$agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$) {
      return null;
    }
    var $cdRootElem$$39_gridId$$3_pivotMonth$$2$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$445$$), $pivotMonthAndYear$$5_pivotYear$$1$$ = $AdfDhtmlChooseDateDOMQueries$$.$getRenderedMonthAndYear$($component$$445$$, $cdRootElem$$39_gridId$$3_pivotMonth$$2$$), $cdRootElem$$39_gridId$$3_pivotMonth$$2$$ = $pivotMonthAndYear$$5_pivotYear$$1$$.getMonth(), $pivotMonthAndYear$$5_pivotYear$$1$$ = $pivotMonthAndYear$$5_pivotYear$$1$$.getFullYear();
    if ($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$ = $AdfDomUtils$$.$getFirstChildElementByAttributeValue$($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$, $AdfDhtmlChooseDatePeer$$.$_YYYY_MM$, $pivotMonthAndYear$$5_pivotYear$$1$$ + "-" + $cdRootElem$$39_gridId$$3_pivotMonth$$2$$)) {
      if ("monthSelector" == $subElementId$$3$$) {
        if ($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$ = $AdfDomUtils$$.$getFirstChildElementByAttributeValue$($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$, "" + $cdRootElem$$39_gridId$$3_pivotMonth$$2$$)) {
          return $agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$;
        }
      } else {
        if ("yearSelector" == $subElementId$$3$$ && ($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$ = $AdfDomUtils$$.$getFirstChildElementByAttributeValue$($agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$, "" + $pivotMonthAndYear$$5_pivotYear$$1$$))) {
          return $agent$$84_grid$$2_monthLink_searchGrid$$1_yearLink$$;
        }
      }
    }
  }
  return null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlChooseDateMonthNavigationHeaderPanel.prototype.getSubIdDomElement", {$getSubIdDomElement$:$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.prototype.$getSubIdDomElement$});
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_queueMonthEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_queueMonthEvent$$($component$$446$$, $panelRoot$$14$$, $monthElement$$) {
  var $cdRootElem$$40$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$446$$);
  if ($AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$446$$, $cdRootElem$$40$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_MONTH_MODE$)) {
    $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueMonthSelectionEvent$($component$$446$$, $cdRootElem$$40$$);
  } else {
    if (!$panelRoot$$14$$ || !$monthElement$$) {
      return !1;
    }
    $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueMonthSelectingEvent$($component$$446$$, $cdRootElem$$40$$, $panelRoot$$14$$, $monthElement$$);
  }
  return !0;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueMonthSelectionEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_setupAndQueueMonthSelectionEvent$$($component$$447$$, $cdRootElem$$41$$) {
  var $displayMode$$3_renderedMonthYear$$ = $AdfAgent$$.$AGENT$.getAttribute($cdRootElem$$41$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_MODE$);
  $AdfAssert$$.assert($displayMode$$3_renderedMonthYear$$ == $AdfDhtmlChooseDatePeer$$.$_DATE_AND_TIME_MODE$);
  $cdRootElem$$41$$.removeAttribute($AdfDhtmlChooseDatePeer$$.$_DISPLAY_SUB_MODE$);
  $displayMode$$3_renderedMonthYear$$ = $AdfDhtmlChooseDateDOMQueries$$.$getRenderedMonthAndYear$($component$$447$$, $cdRootElem$$41$$);
  $AdfChooseDateMonthSelectionEvent$$.$queue$($component$$447$$, $displayMode$$3_renderedMonthYear$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueMonthSelectingEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_setupAndQueueMonthSelectingEvent$$($component$$448$$, $cdRootElem$$42$$, $panelRoot$$15_renderMonthAndYear$$2$$, $monthElement$$1$$) {
  var $agent$$85$$ = $AdfAgent$$.$AGENT$, $displayMode$$4$$ = $agent$$85$$.getAttribute($cdRootElem$$42$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_MODE$);
  $AdfAssert$$.assert($displayMode$$4$$ == $AdfDhtmlChooseDatePeer$$.$_DATE_AND_TIME_MODE$);
  $agent$$85$$.setAttribute($cdRootElem$$42$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_SUB_MODE$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_MONTH_MODE$);
  $panelRoot$$15_renderMonthAndYear$$2$$ = $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_getRenderMonthAndYearIntent$($component$$448$$, $panelRoot$$15_renderMonthAndYear$$2$$, $monthElement$$1$$);
  $AdfDhtmlChooseDateDOMQueries$$.$setRenderedMonthAndYear$($component$$448$$, $cdRootElem$$42$$, $panelRoot$$15_renderMonthAndYear$$2$$);
  $AdfChooseDateMonthSelectingEvent$$.$queue$($component$$448$$, $panelRoot$$15_renderMonthAndYear$$2$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_queueYearEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_queueYearEvent$$($component$$449$$, $panelRoot$$16$$, $yearElement$$) {
  var $cdRootElem$$43$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$449$$);
  if ($AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$449$$, $cdRootElem$$43$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$)) {
    $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueYearSelectionEvent$($component$$449$$, $cdRootElem$$43$$);
  } else {
    if (!$panelRoot$$16$$ || !$yearElement$$) {
      return !1;
    }
    $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueYearSelectingEvent$($component$$449$$, $cdRootElem$$43$$, $panelRoot$$16$$, $yearElement$$);
  }
  return !0;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueYearSelectionEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_setupAndQueueYearSelectionEvent$$($component$$450$$, $cdRootElem$$44$$) {
  var $displayMode$$5_renderedMonthYear$$1$$ = $AdfAgent$$.$AGENT$.getAttribute($cdRootElem$$44$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_MODE$);
  $AdfAssert$$.assert($displayMode$$5_renderedMonthYear$$1$$ == $AdfDhtmlChooseDatePeer$$.$_DATE_AND_TIME_MODE$);
  $cdRootElem$$44$$.removeAttribute($AdfDhtmlChooseDatePeer$$.$_DISPLAY_SUB_MODE$);
  $displayMode$$5_renderedMonthYear$$1$$ = $AdfDhtmlChooseDateDOMQueries$$.$getRenderedMonthAndYear$($component$$450$$, $cdRootElem$$44$$);
  $AdfChooseDateYearSelectionEvent$$.$queue$($component$$450$$, $displayMode$$5_renderedMonthYear$$1$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_setupAndQueueYearSelectingEvent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_setupAndQueueYearSelectingEvent$$($component$$451$$, $cdRootElem$$45$$, $panelRoot$$17_renderMonthAndYear$$3$$, $monthElement$$2$$) {
  var $agent$$86$$ = $AdfAgent$$.$AGENT$, $displayMode$$6$$ = $agent$$86$$.getAttribute($cdRootElem$$45$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_MODE$);
  $AdfAssert$$.assert($displayMode$$6$$ == $AdfDhtmlChooseDatePeer$$.$_DATE_AND_TIME_MODE$);
  $agent$$86$$.setAttribute($cdRootElem$$45$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAY_SUB_MODE$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$);
  $panelRoot$$17_renderMonthAndYear$$3$$ = $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_getRenderMonthAndYearIntent$($component$$451$$, $panelRoot$$17_renderMonthAndYear$$3$$, $monthElement$$2$$);
  $AdfDhtmlChooseDateDOMQueries$$.$setRenderedMonthAndYear$($component$$451$$, $cdRootElem$$45$$, $panelRoot$$17_renderMonthAndYear$$3$$);
  $AdfChooseDateYearSelectingEvent$$.$queue$($component$$451$$, $panelRoot$$17_renderMonthAndYear$$3$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_getRenderMonthAndYearIntent$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_getRenderMonthAndYearIntent$$($component$$452_renderMonthAndYear$$4$$, $panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$, $targetCell_year$$13$$) {
  $AdfAssert$$.$assertPrototype$($component$$452_renderMonthAndYear$$4$$, AdfRichChooseDate);
  $AdfAssert$$.$assertDomElement$($targetCell_year$$13$$);
  var $cdRootElem$$46$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$452_renderMonthAndYear$$4$$);
  $component$$452_renderMonthAndYear$$4$$ = $AdfDhtmlChooseDateDOMQueries$$.$getRenderedMonthAndYear$($component$$452_renderMonthAndYear$$4$$, $cdRootElem$$46$$);
  $panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$ = $AdfDhtmlChooseDateDOMUtils$$.$getParentTableElement$($panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$, $targetCell_year$$13$$);
  $AdfAssert$$.$assertDomElement$($panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$);
  $panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$ = $AdfAgent$$.$AGENT$.getAttribute($panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$, $AdfDhtmlChooseDatePeer$$.$_YYYY_MM$).split("-");
  $AdfAssert$$.assert(2 == $panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$.length);
  $targetCell_year$$13$$ = parseInt($panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$[0]);
  $component$$452_renderMonthAndYear$$4$$.setMonth(parseInt($panelRoot$$18_parentMonthElement_yyyyMmSplits$$1$$[1]));
  $component$$452_renderMonthAndYear$$4$$.setFullYear($targetCell_year$$13$$);
  return $component$$452_renderMonthAndYear$$4$$;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleArrowKeyNavigation$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_handleArrowKeyNavigation$$($componentEvent$$46$$, $panelRootElement$$8$$) {
  var $evt$$57_keyCode$$17$$ = $componentEvent$$46$$.$getNativeEvent$(), $evt$$57_keyCode$$17$$ = $AdfAgent$$.$AGENT$.$getKeyCode$($evt$$57_keyCode$$17$$), $component$$453$$ = $componentEvent$$46$$.getSource(), $eventTarget$$15$$ = $componentEvent$$46$$.$getNativeEventTarget$(), $isRtl$$2$$ = $AdfPage$$.$PAGE$.$getLocaleContext$().$isRightToLeft$(), $nextElementToFocus$$ = null;
  switch($evt$$57_keyCode$$17$$) {
    case $AdfKeyStroke$$.$ARROWRIGHT_KEY$:
    ;
    case $AdfKeyStroke$$.$ARROWDOWN_KEY$:
      $nextElementToFocus$$ = $isRtl$$2$$ ? $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleLeftNavigation$($eventTarget$$15$$, $component$$453$$) : $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleRightNavigation$($eventTarget$$15$$, $component$$453$$);
      break;
    case $AdfKeyStroke$$.$ARROWUP_KEY$:
    ;
    case $AdfKeyStroke$$.$ARROWLEFT_KEY$:
      $nextElementToFocus$$ = $isRtl$$2$$ ? $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleRightNavigation$($eventTarget$$15$$, $component$$453$$) : $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleLeftNavigation$($eventTarget$$15$$, $component$$453$$);
  }
  return $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_focusCell$($eventTarget$$15$$, $nextElementToFocus$$, $panelRootElement$$8$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleRightNavigation$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_handleRightNavigation$$($eventTarget$$16$$, $component$$454$$) {
  var $cdRootElem$$47_nextTable_parentTable$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$454$$), $isYearSelectingMode$$15$$ = $AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$454$$, $cdRootElem$$47_nextTable_parentTable$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$), $nextElementToFocus$$1$$ = $AdfDomUtils$$.$getNextElement$($eventTarget$$16$$);
  !$nextElementToFocus$$1$$ && ($cdRootElem$$47_nextTable_parentTable$$ = $AdfDhtmlChooseDateDOMUtils$$.$getParentTableElement$($cdRootElem$$47_nextTable_parentTable$$, $eventTarget$$16$$), $AdfAssert$$.$assertDomElement$($cdRootElem$$47_nextTable_parentTable$$), $cdRootElem$$47_nextTable_parentTable$$ = $AdfDomUtils$$.$getNextElement$($cdRootElem$$47_nextTable_parentTable$$)) && ($nextElementToFocus$$1$$ = ($isYearSelectingMode$$15$$ ? $AdfDomUtils$$.$getLastElementByTagName$ : $AdfDomUtils$$.$getFirstElementByTagName$)($cdRootElem$$47_nextTable_parentTable$$, 
  $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$), $AdfAssert$$.$assertDomElement$($nextElementToFocus$$1$$));
  return $nextElementToFocus$$1$$;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_handleLeftNavigation$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_handleLeftNavigation$$($eventTarget$$17$$, $component$$455$$) {
  var $cdRootElem$$48_parentTable$$1_previousTable$$ = $AdfDhtmlChooseDateDOMQueries$$.$getDOMElement$($component$$455$$), $nextElementToFocus$$2$$ = $AdfDhtmlChooseDateDOMQueries$$.$checkCurrentDisplaySubMode$($component$$455$$, $cdRootElem$$48_parentTable$$1_previousTable$$, $AdfDhtmlChooseDatePeer$$.$_DATE_TIME_SUB_YEAR_MODE$) ? null : $AdfDomUtils$$.$getPreviousElement$($eventTarget$$17$$);
  !$nextElementToFocus$$2$$ && ($cdRootElem$$48_parentTable$$1_previousTable$$ = $AdfDhtmlChooseDateDOMUtils$$.$getParentTableElement$($cdRootElem$$48_parentTable$$1_previousTable$$, $eventTarget$$17$$), $AdfAssert$$.$assertDomElement$($cdRootElem$$48_parentTable$$1_previousTable$$), $cdRootElem$$48_parentTable$$1_previousTable$$ = $AdfDomUtils$$.$getPreviousElement$($cdRootElem$$48_parentTable$$1_previousTable$$)) && ($nextElementToFocus$$2$$ = $AdfDomUtils$$.$getLastElementByTagName$($cdRootElem$$48_parentTable$$1_previousTable$$, 
  $AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$), $AdfAssert$$.$assertDomElement$($nextElementToFocus$$2$$));
  return $nextElementToFocus$$2$$;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_focusCell$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_focusCell$$($cellWithFocus$$1$$, $cellToFocus$$1$$, $monthAttrVal$$1_panelRoot$$19$$) {
  if ($cellToFocus$$1$$ && $AdfDomUtils$$.$isAncestor$($monthAttrVal$$1_panelRoot$$19$$, $cellToFocus$$1$$)) {
    var $agent$$87_yearAttrVal$$1$$ = $AdfAgent$$.$AGENT$;
    $monthAttrVal$$1_panelRoot$$19$$ = $agent$$87_yearAttrVal$$1$$.getAttribute($cellToFocus$$1$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_MONTH$);
    $agent$$87_yearAttrVal$$1$$ = $agent$$87_yearAttrVal$$1$$.getAttribute($cellToFocus$$1$$, $AdfDhtmlChooseDatePeer$$.$_DISPLAYED_YEAR$);
    if (null != $monthAttrVal$$1_panelRoot$$19$$ || null != $agent$$87_yearAttrVal$$1$$) {
      return $cellWithFocus$$1$$ && $cellWithFocus$$1$$.setAttribute("tabIndex", "-1"), $cellToFocus$$1$$.setAttribute("tabIndex", "0"), $AdfFocusUtils$$.$focusElement$($cellToFocus$$1$$), !0;
    }
  }
  return !1;
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_eventTargetsElementWithAttribute$ = function $$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$$$_eventTargetsElementWithAttribute$$($componentEvent$$47$$, $attributeName$$) {
  return null != $AdfAgent$$.$AGENT$.getAttribute($componentEvent$$47$$.$getNativeEventTarget$(), $attributeName$$);
};
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_SELECTING_MONTH_AND_YEAR$ = "data-afr-selecting-month-year";
$AdfDhtmlChooseDateMonthNavigationHeaderPanel$$.$_MONTH_YEAR_CELL_NODE_TYPE$ = "DIV";
